# TODO
# - ix86/x32 (php -m) prints::
#   src/mongoc/mongoc-handshake.c:478 _append_and_truncate(): precondition failed: space_for_suffix >= 0
#   Aborted
#
# Conditional build:
%bcond_without	tests		# build without tests
%bcond_with	sasl		# Include Cyrus SASL support (for bundled only)
%bcond_without	ssl		# Enable TLS connections and SCRAM-SHA-1 authentication (for bundled only)
%bcond_with	bundled		# Use bundled libbson, libmongoc

%define		php_name	php%{?php_suffix}
%define		modname	mongodb
Summary:	MongoDB driver for PHP
Name:		%{php_name}-pecl-%{modname}
Version:	1.4.2
Release:	2
License:	Apache v2.0
Group:		Development/Languages/PHP
Source0:	https://pecl.php.net/get/%{modname}-%{version}.tgz
# Source0-md5:	28084c896be33df1ca268898646b7e32
Patch0:		php-version.patch
Source1:	mongodb.ini
URL:		https://pecl.php.net/package/mongodb
BuildRequires:	%{php_name}-cli
BuildRequires:	%{php_name}-devel >= 4:5.4.0
BuildRequires:	%{php_name}-json
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-spl
%{?with_sasl:BuildRequires:	cyrus-sasl-devel}
%if %{without bundled}
BuildRequires:	libbson-devel >= 1.8.0
BuildRequires:	mongo-c-driver-devel >= 1.9
%endif
BuildRequires:	openssl-devel
BuildRequires:	rpmbuild(macros) >= 1.666
Requires:	%{php_name}-json
Requires:	mongo-c-driver-libs >= 1.9.3-2
Requires:	%{php_name}-pcre
Requires:	%{php_name}-spl
%{?requires_php_extension}
Provides:	php(%{modname}) = %{version}
ExcludeArch:	%{ix86} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The purpose of this driver is to provide exceptionally thin glue
between MongoDB and PHP, implementing only fundemental and
performance-critical components necessary to build a fully-functional
MongoDB driver.

%prep
%setup -qc
mv %{modname}-%{version}/* .
%patch0 -p1

%if %{without bundled}
# Ensure we use system library
# remove only C sources, m4 resources needed for phpize via m4_include
find \
	src/libbson \
	src/libmongoc \
	-name '*.[ch]' | xargs %{__rm} -v
%endif

%build
# Sanity check, really often broken
extver=$(sed -n '/#define PHP_MONGODB_VERSION/{s/.* "//;s/".*$//;p}' php_phongo.h)
if test "x${extver}" != "x%{version}"; then
	: Error: Upstream extension version is ${extver}, expecting %{version}.
	exit 1
fi

phpize

%configure \
	--with-libbson=%{?with_bundled:no}%{!?with_bundled:yes} \
	--with-libmongoc=%{?with_bundled:no}%{!?with_bundled:yes} \
	--with-mongodb-ssl=%{!?with_ssl:no}%{?with_ssl:openssl} \
	--with-mongodb-sasl=%{!?with_sasl:no}%{?with_sasl:yes} \
	--enable-mongodb

%{__make}

# simple module load test, always enabled
%{__php} -n -q \
	-d extension_dir=modules \
	-d extension=%{php_extensiondir}/pcre.so \
	-d extension=%{php_extensiondir}/spl.so \
	-d extension=%{php_extensiondir}/json.so \
	-d extension=%{modname}.so \
	-m > modules.log
grep %{modname} modules.log

%if %{with tests}
cat <<'EOF' > run-tests.sh
#!/bin/sh
export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
exec %{__make} test \
	PHP_EXECUTABLE=%{__php} \
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="pcre spl json" \
	RUN_TESTS_SETTINGS="-q $*"
EOF
chmod +x run-tests.sh

./run-tests.sh
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	EXTENSION_DIR=%{php_extensiondir} \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so
%changelog
* Thu Apr 12 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-mongodb.git;a=log;h=auto/th/php-pecl-mongodb-1.4.2-2

* Thu Apr 12 2018 Elan Ruusamäe <glen@pld-linux.org> b3161ed
- Revert "re-order after openssl module"

* Mon Apr 02 2018 Elan Ruusamäe <glen@pld-linux.org> ee0b9bb
- it still compiles with php 5.4, so allow building it

* Mon Apr 02 2018 Elan Ruusamäe <glen@pld-linux.org> 3bff6cd
- re-order after openssl module

* Wed Mar 28 2018 Elan Ruusamäe <glen@pld-linux.org> 3cfe18c
- up to 1.4.2

* Fri Nov 03 2017 Elan Ruusamäe <glen@pld-linux.org> 720d9dc
- up to 1.3.2

* Sun Oct 29 2017 Elan Ruusamäe <glen@pld-linux.org> 463d8c7
- up to 1.3.1; still crashes on shutdown

* Sun Oct 29 2017 Elan Ruusamäe <glen@pld-linux.org> 8cb3090
- clean sources in prep except .m4

* Sun Oct 29 2017 Elan Ruusamäe <glen@pld-linux.org> bc94cad
- add sasl bcond.

* Sat Oct 28 2017 Elan Ruusamäe <glen@pld-linux.org> d42acda
- consistent build: --with-mongodb-sasl

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> 72c237b
- disable 32bit arches - broken

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> 9d61e51
- update runtime deps as well

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> 7ac97c3
- pcre for i686/x32 again

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> a88e399
- module load test is always performed

* Fri Oct 27 2017 Elan Ruusamäe <glen@pld-linux.org> 2782ab3
- R: cli for tests

* Tue Oct 17 2017 Elan Ruusamäe <glen@pld-linux.org> bf153e4
- fix .ini packaging

* Tue Oct 17 2017 Elan Ruusamäe <glen@pld-linux.org> 82d879f
- disable failed test data

* Tue Oct 17 2017 Elan Ruusamäe <glen@pld-linux.org> 29b44cd
- version .ini file separately

* Tue Oct 17 2017 Elan Ruusamäe <glen@pld-linux.org> c485d9e
- always run module load test

* Tue Oct 17 2017 Elan Ruusamäe <glen@pld-linux.org> 4b7a708
- spl for tests

* Mon Oct 16 2017 Elan Ruusamäe <glen@pld-linux.org> 78f25fe
- up to 1.2.11

